      SUBROUTINE SF68R(X0,R0,T10,T20)
         REAL R0,T10,T20,X0
         EXTERNAL SF68R2,SF68R3
         COMMON /SF68R1/X
         INTEGER C,IERR,IMET1,IMET2,K,K1,L,L1,L2,M,M1,N
         REAL A,A0,A1,A2,A3,A4,ALOG,ARGI,ARGR,B,B1,B2,B3,B4,C1,C2,C3,
     1        C4,COS,E,EPS,EXP,F,F1,FI,G,G1,G2,G3,H,H1,H2,H3,H4,P1,P2,
     2        PI,R,RINT1,RINT2,S,S1,S10,S2,S20,SF68R2,SF68R3,SIN,SQRT,
     3        SYS001,U,U1,U2,V,V1,V2,X
         LOGICAL Q
         DIMENSION A1(17,17),A2(17,17),B1(17,17),B2(17,17),C(17,17),
     1             G1(17),G2(17),H1(17),H2(17),P1(17),P2(17),U1(17),
     2             U2(17),V1(17),V2(17)
         EQUIVALENCE (SYS001,PI)
         DATA SYS001/3.141593/,EPS1/1.E-6/,EPS2/1.E-5/
       X = X0
       R = R0
       IF (X0 .LE. 6. .OR. R0 .GE. 4.) GO TO 10
          IF (R0 .GT. 0. .AND. R0 .LE. 1. .AND. X0 .GT. 6. .OR.
     1       R0 .GT. 1. .AND. R0 .LE. 2. .AND. X0 .GT. 7.) GO TO 30
             IF (R0 .GT. 2. .AND. R0 .LE. 3. .AND. X0 .GT. 8. .OR.
     1          R0 .GT. 3. .AND. R0 .LE. 4. .AND. X0 .GT. 9.) GO TO 50
   10        CONTINUE
             IMET1 = 0
             GO TO 140
   20  CONTINUE
       T10 = S10
       GO TO 70
   30  CONTINUE
       IMET2 = 0
       GO TO 160
   40  CONTINUE
       T10 = S1
       GO TO 70
   50  CONTINUE
       Q = .FALSE.
       GO TO 270
   60  CONTINUE
       T10 = S
   70  CONTINUE
       IF (X0 .LE. 4. .OR. R0 .GE. 6.) GO TO 80
          IF (R0 .GT. 0. .AND. R0 .LE. 1. .AND. X0 .GT. 4. .OR.
     1       R0 .GT. 1. .AND. R0 .LE. 2. .AND. X0 .GT. 6.) GO TO 100
             IF (R0 .GT. 2. .AND. R0 .LE. 3. .AND. X0 .GT. 6. .OR.
     1          R0 .GT. 3. .AND. R0 .LE. 4. .AND. X0 .GT. 8. .OR.
     2          R0 .GT. 4. .AND. R0 .LE. 6. .AND. X0 .GT. 9.) GO TO 120
   80        CONTINUE
             IMET1 = 1
             GO TO 140
   90  CONTINUE
       T20 = S20
       GO TO 300
  100  CONTINUE
       IMET2 = 1
       GO TO 160
  110  CONTINUE
       T20 = S2
       GO TO 300
  120  CONTINUE
       Q = .TRUE.
       GO TO 270
  130  CONTINUE
       T20 = S
       GO TO 300
C     HAAO BCEH KOMEKCHO AMMA-YHK
  140  CONTINUE
       EPS = EPS1
       L = 1
       ARGR = 1.5
       ARGI = R
       CALL SF23C(ARGR,ARGI,U,V,EPS,L,IERR)
C     OKOHAHE BCEH KOMEKCHO AMMA-YHK
       F = SQRT(X/2.)*COS(R*ALOG(X/2.))
       G = SQRT(X/2.)*SIN(R*ALOG(X/2.))
       A = (F*U + G*V)/(U**2 + V**2)
       B = (G*U - F*V)/(U**2 + V**2)
       S1 = A
       S2 = B
       F = COS(R*ALOG(X/2.))/SQRT(X/2.)
       G = -SIN(R*ALOG(X/2.))/SQRT(X/2.)
       F1 = F/2.+ G*R
       G3 = G/2.- F*R
       A3 = (F1*U - G3*V)/(U**2 + V**2)
       B3 = (G3*U + F1*V)/(U**2 + V**2)
       H3 = A3
       H4 = B3
       H = PI/(EXP(PI*R) + EXP(-PI*R))
       DO 150 K = 1, 55
          C3 = A
          C4 = A3
          A = X**2*(A*(K + 0.5) + B*R)/(4*K*((K + 0.5)**2+R**2))
          B = X**2*(B*(K + 0.5) - C3*R)/(4*K*((K + 0.5)**2+R**2))
          A3 = X**2*(A3*(K - 0.5) - B3*R)/(4*K*((K - 0.5)**2+R**2))
          B3 = X**2*(C4*R + B3*(K - 0.5))/(4*K*((K - 0.5)**2+R**2))
          S1 = S1 + A
          S2 = S2 + B
          H3 = H3 + A3
          H4 = H4 + B3
  150  CONTINUE
       S10 = (H3 - S1)*H
       S20 = (H4 - S2)*H
       IF (IMET1) 20, 20, 90
  160  CONTINUE
       DO 180 N = 2, 17
          C(1,N) = (-1)**(N - 1)
          DO 170 M = 2, N
             C(M,N) = -C(M-1,N)*2*(N + M - 3)*(N - M + 1)/((M - 1)*
     1                (2*(M - 1)))
  170     CONTINUE
  180  CONTINUE
       A1(1,1) = 1./(R*(R**2 + 1.))
       B1(1,1) = 1./(R**2 + 1.)
       A2(1,1) = 1./(R**2 + 1.)
       B2(1,1) = -1./(R*(R**2 + 1.))
       H1(1) = A1(1,1)
       P1(1) = B1(1,1)
       H2(1) = A2(1,1)
       P2(1) = B2(1,1)
       DO 200 M = 2, 17
          C1 = R**2 + M*(M - 1)
          A1(M,M) = R/((C1)**2 + R**2)
          B1(M,M) = C1/((C1)**2 + R**2)
          A2(M,M) = C1/((C1)**2 + R**2)
          B2(M,M) = -R/((C1)**2 + R**2)
          M1 = M - 1
          DO 190 K1 = 1, M1, 1
             K = M - K1
             C2 = R**2 + K*(K - 1)
             A1(K,M) = -2.*K*(R*B1(K+1,M) + C2*A1(K+1,M))/((C2)**2 +
     1                 R**2)
             B1(K,M) = 2.*K*(R*A1(K+1,M) - C2*B1(K+1,M))/((C2)**2 +
     1                 R**2)
             A2(K,M) = -2.*K*(R*B2(K+1,M) + C2*A2(K+1,M))/((C2)**2 +
     1                 R**2)
             B2(K,M) = 2.*K*(R*A2(K+1,M) - C2*B2(K+1,M))/((C2)**2 +
     1                 R**2)
  190     CONTINUE
  200  CONTINUE
       DO 220 N = 2, 17, 1
          U1(N) = 0
          U2(N) = 0
          V1(N) = 0
          V2(N) = 0
          DO 210 M = 1, N, 1
             U1(N) = U1(N) + C(M,N)*B1(1,M)
             U2(N) = U2(N) + C(M,N)*A1(1,M)
             V1(N) = V1(N) + C(M,N)*B2(1,M)
             V2(N) = V2(N) + C(M,N)*A2(1,M)
  210     CONTINUE
          G1(N) = V2(N)/(U1(N)*V2(N) - U2(N)*V1(N))
          G2(N) = U2(N)/(V1(N)*U2(N) - V2(N)*U1(N))
  220  CONTINUE
       DO 240 M = 2, 17, 1
          P1(M) = 0
          H1(M) = 0
          P2(M) = 0
          H2(M) = 0
          DO 230 K = 1, M, 1
             P1(M) = P1(M) + B1(K,M)*(1./X)**(K - 1)
             H1(M) = H1(M) + A1(K,M)*(1./X)**(K - 1)
             P2(M) = P2(M) + B2(K,M)*(1./X)**(K - 1)
             H2(M) = H2(M) + A2(K,M)*(1./X)**(K - 1)
  230     CONTINUE
  240  CONTINUE
       DO 260 N = 2, 17, 1
          S1 = 0
          S2 = 0
          DO 250 M = 1, N, 1
             S1 = S1 + C(M,N)*(G1(N)*P1(M) + G2(N)*P2(M))
             S2 = S2 + C(M,N)*(G1(N)*H1(M) + G2(N)*H2(M))
  250     CONTINUE
  260  CONTINUE
       S1 = SQRT(PI/(2.*X))*EXP(-X)*S1
       S2 = SQRT(PI/(2.*X))*EXP(-X)*S2
       IF (IMET2) 40, 40, 110
  270  CONTINUE
       A4 = 0.
       B4 = 5.
       FI = 0.
       E = EPS2
       L1 = 0
       L2 = 1
       IF (Q) GO TO 280
          CALL QSF3R(RINT1,RINT2,A4,B4,SF68R2,R,FI,E,L1,L2)
          A0 = RINT2
          GO TO 290
  280  CONTINUE
       CALL QSF3R(RINT1,RINT2,A4,B4,SF68R3,R,FI,E,L1,L2)
       A0 = RINT1
  290  CONTINUE
       S = A0*EXP(-X)/2.
       IF (Q) GO TO 130
          GO TO 60
  300  CONTINUE
       RETURN
      END
